/*
 * RGBledswitch
 * Nyomógombbal sorban léptetjük 0 és 7 között az RGB LED színkódjait, melynek
 * értelmezése: 0. bit = piros, 1. bit = zöld 2. bit = kék alapszín.
 * A 0 színkód azt jelenti, hogy kikapcsolva hagyjuk az összes alapszínt (fekete).
 *
 * Hardver követelmények: Arduino kártya, közös katódú RGB LED a 
 * D3, D5, D6 kivezetésekre kötve, nyomógomb D4 és a föld közé kötve.
 */
#define LED_RED    3
#define LED_BLUE   5
#define LED_GREEN  6
#define PUSH2      4

int color = 1;                          //színkód (0..7)
boolean waitforpress = true;

void setup() {                
	// Kimenetként inicialzáljuk a LED vezérlő lábakat
	pinMode(LED_RED, OUTPUT);     
	pinMode(LED_BLUE, OUTPUT);     
	pinMode(LED_GREEN, OUTPUT);     
	pinMode(PUSH2,INPUT_PULLUP);  
}

void loop() {
	if(waitforpress) {	//Ha lenyomásra várunk és
		if(!digitalRead(PUSH2)) {	//Ha lenyomás történt...
			color = ++color & 0x07;    //Szín léptetése
			digitalWrite(LED_RED, color & 1);    // piros LED ki
			digitalWrite(LED_GREEN, (color & 2)>0);  // zöld LED ki
			digitalWrite(LED_BLUE, (color & 4)>0);   // kék LED ki
			waitforpress = false;      //Következő stáció: felengedésre várunk
		}
	}  
	else {	//Ha felengedésre vártunk és
		if(digitalRead(PUSH2)) {	//Ha felengedést észlelünk...
			waitforpress = true;       //Következő stáció: lenyomásra várunk
		}
	}  
	delay(20);                    //pergésmentesítő késleltetés  
}


